<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-primary self-end"
        v-text="'Planos'"
      />

      <q-btn
        class="super-rounded-borders"
        style="width: 272px"
        label="Novo Plano"
        color="primary"
        padding="14px"
        @click="edit()"
      />
    </div>

    <table-view
      class="col-12"
      :columns="columns"
      :table-data="tableData"
      sort-by="id"
      @reload="asyncReload('tableData')"
    />
  </q-page>
</template>

<script>
import TableView from 'components/plan/table-view'
import FormPlan from 'components/plan/form-plan'
import { formatToBRL } from 'brazilian-values'

const formFactory = JSON.stringify({
  title: '',
  subtitle: '',
  description: '',
  price: '',
  installments: 1,
  benefits: [],
  buttonLabel: '',
  color: '',
  recommended: false,
  isEnable: true
})

export default {
  name: 'PagePlans',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Plans'
        }

        const Response = await this.$axios(axiosConfig).then(R => R.data)

        await Response.map((plan) => (plan.price = Number(plan.price).toFixed(2)))

        return Response
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'title', field: 'title', label: 'Título', align: 'left', sortable: true },
        { name: 'subtitle', field: 'subtitle', label: 'Subtítulo', align: 'left', sortable: true },
        { name: 'description', field: 'description', label: 'Descrição', align: 'left', sortable: true },
        { name: 'price', field: 'price', label: 'Preço', align: 'left', sortable: true, format: (val) => formatToBRL(val) },
        { name: 'installments', field: 'installments', label: 'Parcelas', align: 'left', sortable: true },
        { name: 'buttonLabel', field: 'buttonLabel', label: 'Texto do Botão', align: 'left', sortable: true },
        { name: 'color', field: 'color', label: 'Cor', align: 'left', sortable: true },
        { name: 'action', field: 'action', label: 'Ações', align: 'center' }
      ]
    }
  },
  methods: {
    edit (row = JSON.parse(formFactory)) {
      this.$q.dialog({
        component: FormPlan,
        value: Object.assign({}, row),
        parent: this
      }).onOk(() => {
        this.asyncReload('tableData')
      })
    }
  }
}
</script>
